## happy 1.16~rc2

=== Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

SUBDIRS = src templates doc

include $(TOP)/mk/target.mk

=== tests/Makefile ===
HAPPY=happy
HC=ghc

TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
	monad001.y monad002.ly precedence001.ly precedence002.y \
	bogus-token.y bug002.y Partial.ly \
	AttrGrammar001.y AttrGrammar002.y

TEST_HAPPY_OPTS = --strict 

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
HS_PROG_EXT = .exe
else
HS_PROG_EXT = .bin
endif

%.n.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) $< -o $@

%.a.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) -a $< -o $@

%.g.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) -g $< -o $@

%.gc.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) -gc $< -o $@

%.ag.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) -ag $< -o $@

%.agc.hs : %.ly
	$(HAPPY) $(TEST_HAPPY_OPTS) -agc $< -o $@

%.n.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) $< -o $@

%.a.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) -a $< -o $@

%.g.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) -g $< -o $@

%.gc.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) -gc $< -o $@

%.ag.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) -ag $< -o $@

%.agc.hs : %.y
	$(HAPPY) $(TEST_HAPPY_OPTS) -agc $< -o $@

%.o : %.hs
	$(HC) $(HC_OPTS) -c -o $@ $<

CLEAN_FILES += *.n.hs *.a.hs *.g.hs *.gc.hs *.ag.hs *.agc.hs *.info *.hi *.bin *.exe

ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}y/\1.n.hs \1.a.hs \1.g.hs \1.gc.hs \1.ag.hs \1.agc.hs/g')

ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))

HC_OPTS += -fglasgow-exts -package lang

.PRECIOUS: *.hs *.o *.bin *.exe

%.run : %$(HS_PROG_EXT)
	./$<

%$(HS_PROG_EXT) : %.o
	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@

all :: $(ALL_TESTS)

check-todo::
	$(HAPPY) -ad Test.ly
	$(HC) Test.hs -o happy_test
	./happy_test
	-rm -f ./happy_test
	$(HAPPY) -agd Test.ly
	$(HC) Test.hs -o happy_test
	./happy_test
	-rm -f ./happy_test
	$(HAPPY) -agcd Test.ly
	$(HC) Test.hs -o happy_test
	./happy_test
	-rm -f ./happy_test

=== examples/glr/bio-eg/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

PROG=bio-eg

# filtering causes this example to fail...
FILTER = --filter
FILTER =

.hi.o :
	@ dummy 

${PROG} : Bio.o Main.lhs 
	${GHC} -cpp -fglasgow-exts -package lang -o ${PROG} --make Main.lhs

BioData.hs Bio.hs : Bio.y
	${HAPPY} --info --glr --ghc ${FILTER} $< 

Bio.o : Bio.hs BioData.hi
	${GHC} -cpp -fglasgow-exts -package lang -O2 -c Bio.hs

DATA_FLAGS = -funfolding-use-threshold0 -fno-strictness 
BioData.hi BioData.o : BioData.hs 
	@echo "Making BioData.hs WITHOUT optimisation (for speed)"
	${GHC} -cpp -fglasgow-exts -package lang ${DATA_FLAGS} -c $<

run : run12 

run6 : ${PROG}
	./${PROG} +RTS -s -K5M -RTS `cat 1-600.dna`

run12 : ${PROG}
	rm -f out.1200
	./${PROG} +RTS -s -K15M -RTS `cat 1-1200.dna` >& out.1200
	echo Expect NINE matches, got `grep '^[(,0-9]*G_Match' out.1200 | wc -l`

clean :
	rm -rf ${PROG} Bio.info Bio.hs BioData.hs *.o *.hi out.daVinci \
		out.1200 out.600

=== examples/glr/expr-eval/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

OPT = -O
DECODE = --decode

expr : Expr.hs Main.lhs 
	# might want to run happy with --ghc
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs

run : expr
	./expr "1+2*4-3"

runn : expr
	./expr +RTS -s -RTS `perl -e 'print join ("+", (1 .. ${NUM}));'` | tee out-${NUM}
	cat expr.stat >> out-${NUM}

eof : expr
	echo testing premature eof
	./expr "1+2*"

err : expr
	echo testing syntax error 
	./expr "1+2*2++3"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== examples/glr/expr-monad/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

DECODE = --decode


expr : Expr.hs Main.lhs 
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs

run : expr
	./expr "1+2*4-3"

eof : expr
	echo testing premature eof
	./expr "1+2*"

err : expr
	echo testing syntax error 
	./expr "1+2*2++3"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== examples/glr/expr-tree/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

OPT = -O2

expr : Expr.hs Main.lhs 
	# might want to run happy with --ghc
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
                                                                                
run : expr
	./expr "1+2*4-3"

runn : expr
	./expr +RTS -s -RTS `perl -e 'print join ("+", (1 .. ${NUM}));'` | tee out-${NUM}
	cat expr.stat >> out-${NUM}


eof : expr
	echo testing premature eof
	./expr "1+2*"

err : expr
	echo testing syntax error 
	./expr "1+2*2++3"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== examples/glr/hidden-leftrec/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

expr : Expr.hs Main.lhs
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs

run : expr
	./expr "+ 1 1 1 1 1 1 "

eof : expr
	echo testing premature eof
	./expr ""

err : expr
	echo testing syntax error 
	./expr "+ 1 +"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

=== examples/glr/highly-ambiguous/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

expr : Expr.hs Main.lhs
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs

NUM=20
run : expr
	./expr +RTS -s -RTS ${NUM} | grep ^Ok
	egrep '' expr.stat > out${NUM}

run30 : 
	make run NUM=30

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

tar :
	tar chzf aj2.tgz Expr*hs Expr*y Main*hs D*hs

=== examples/glr/nlp/Makefile ===
TOP=..
include ${TOP}/Makefile.defs

english : English.hs Main.lhs 
	${GHC} -cpp -fglasgow-exts -package lang -o english --make Main.lhs

run : english
	./english "the man saw the race with a telescope"

eof : english
	echo testing premature eof
	./english "the man saw a"

err : english
	echo testing syntax error 
	./english "the the man saw race"

test : run eof err

clean :
	rm -rf english English.info English.hs EnglishData.hs *.o *.hi out.daVinci

=== examples/glr/packing/Makefile ===
TOP = ..
include $(TOP)/Makefile.defs

FILTER = --filter
FILTER = 

.y.hs : 
	${HAPPY} -i -l $*.y ${FILTER}

expr : Expr.hs Main.lhs
	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs

run : expr
	./expr "+ 1 1 1 1 1 1 "

eof : expr
	echo testing premature eof
	./expr ""

err : expr
	echo testing syntax error 
	./expr "+ 1 +"

test : run eof err

clean :
	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci

## happy 1.17

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-HAPPY=happy
+HAPPY=../dist/build/happy/happy
 HC=ghc
 
 TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
@@ -6,7 +6,9 @@
 	bogus-token.y bug002.y Partial.ly \
 	AttrGrammar001.y AttrGrammar002.y
 
-TEST_HAPPY_OPTS = --strict 
+ERROR_TESTS = error001.y
+
+TEST_HAPPY_OPTS = --strict --template=..
 
 ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
 HS_PROG_EXT = .exe
@@ -59,28 +61,37 @@
 
 ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))
 
-HC_OPTS += -fglasgow-exts -package lang
+CHECK_ERROR_TESTS = $(patsubst %, check.%, $(ERROR_TESTS))
+
+HC_OPTS += -fglasgow-exts -no-recomp
 
 .PRECIOUS: *.hs *.o *.bin *.exe
 
 %.run : %$(HS_PROG_EXT)
+	@echo "--> Checking $<..."
 	./$<
+
+check.%.y : %.y
+	@echo "--> Checking $<..."
+	$(HAPPY) $(TEST_HAPPY_OPTS) $< 1>$*.run.stdout 2>$*.run.stderr || true
+	@diff -u $*.stdout $*.run.stdout
+	@diff -u $*.stderr $*.run.stderr
 
 %$(HS_PROG_EXT) : %.o
 	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@
 
-all :: $(ALL_TESTS)
+all :: $(CHECK_ERROR_TESTS) $(ALL_TESTS)
 
 check-todo::
-	$(HAPPY) -ad Test.ly
+	$(HAPPY) $(TEST_HAPPY_OPTS) -ad Test.ly
 	$(HC) Test.hs -o happy_test
 	./happy_test
 	-rm -f ./happy_test
-	$(HAPPY) -agd Test.ly
+	$(HAPPY) $(TEST_HAPPY_OPTS) -agd Test.ly
 	$(HC) Test.hs -o happy_test
 	./happy_test
 	-rm -f ./happy_test
-	$(HAPPY) -agcd Test.ly
+	$(HAPPY) $(TEST_HAPPY_OPTS) -agcd Test.ly
 	$(HC) Test.hs -o happy_test
 	./happy_test
 	-rm -f ./happy_test

## happy 1.18.4

=== debian/changelog ===
happy (1.18.4-2) unstable; urgency=low

  [ Iain Lane ]
  * debian/rules: Remove doc/configure in clean, forgotten before and caused
    package to be unclean.

  [ Marco Túlio Gontijo e Silva ]
  * debian/control: Change Priority: to extra.
  * debian/watch: Use format that works for --download-current-version.
  * debian/watch: Add .tar.gz to downloaded filename.
  * debian/watch: Include package name in downloaded .tar.gz.
  * debian/watch: Remove spaces, since they're not allowed by uscan.
  * debian/control: Bump Standards-Version: to 3.8.4, no changes needed.
  * debian/control: Bump version of Build-Depends: on haskell-devscripts
    to 0.7 and remove versioned Build-Depends: on ghc6.
  * Use 3.0 (quilt) format.

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Sun, 21 Feb 2010 07:31:12 -0300

happy (1.18.4-1) unstable; urgency=low

  * New upstream release 1.18.4
    - New feature: EBNF-style paramterized macros, thanks to
      Iavor Diatchki.
    - Works with Cabal 1.2, 1.4 and 1.6
    - A few minor bugfixes
      + Manpage now correctly specifies options required for -d to work
        (Closes: #326952)
  * debian/control, debian/copyright, debian/rules: Adopt for Debian Haskell
    Group, add myself to Uploaders and remove Ian Lynagh (Igloo). Thanks for
    your previous maintainership. Add VCS information.
  * debian/control: Update long description
  * debian/control: Standards-version 3.8.3
    - Section: haskell
    - Add debian/README.source for new patchsys
  * debian/rules, debian/control, debian/happy.*, debian/compat: Fairly major
    rewrite to use cdbs and hlibrary.mk
  * debian/control, debian/patches/templates_path.patch, debian/rules: Add
    quilt patchsys and patch Setup.lhs to install templates in out/ directory.
    They are usually installed in the build root which means there is no easy
    way to install them all at once.
  * debian/rules, debian/control: Upstream doesn't ship doc/configure required
    for the doc build - use autoconf to generate it at build-time. Requires a
    build-dep on autoconf.

 -- Iain Lane <laney@ubuntu.com>  Sun, 04 Oct 2009 13:31:04 +0100

happy (1.17-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch from Ruben Molina and Matt Kraai to fix FTBFS with a 
    recent GHC6. (Closes: #516425).

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 17 Aug 2009 18:26:15 +0200

happy (1.17-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release: (Closes: #470942)
    - Cabal 1.2 is now required. (Closes: #460375)
    - Works with upcoming GHC 6.8.1
    - Fix the 'parE' bug (poor error message for errors in the grammar)
    - Some performance improvements to Happy itsel
  * debian/control:
    - Added Homepage field.
    - Bump the build dependency on ghc6 to 6.8.2 as the packages needs
      Cabal 1.2 to build.
    - Bump the Standards-Version to 3.7.3. No changes needed.
    - Add happy and libghc6-mtl-dev to the build dependencies.
  * debian/copyright:
    - Fix debian-copyright-file-uses-obsolete-national-encoding lintian
      warning.
    - Update debian/copyright file with info from upstream LICENSE file.
  * debian/doc-base:
    - Adjust section to Programming/Haskell
  * debian/get_version.hs: Updated for Cabal 1.2
  * debian/rules:
    - Fix debian-rules-ignores-make-clean-error lintian warning.
    - Remove the LICENSE installed by ./setup copy
  
 -- Arjan Oosting <arjan@debian.org>  Thu, 01 May 2008 12:05:29 +0200

happy (1.16~rc2-1) unstable; urgency=low

  * New upstream (release candidate) version.
  * Removed happy/ prefixes from various paths in debian/rules and
    debian/docs.
  * doc/configure generated by autoconf is in the Debian diff.
  * Build using cabal:
    * Various debian/rules changes.
    * Create debian/get_version.hs for extracting the version from the cabal
      file.
    * Requires ghc6 >= 6.4.2.
    * No longer tries to detect platform. Closes: #340325, #332979.
    * Removed autotool-dev build-dep.
  * Add 'XSLTPROC_OPTS = --nonet' to doc/config.mk.in.
  * Remove src/Parser.ly and src/AttrGrammarParser.ly before cleaning so
    the generated files don't get cleaned.
  * Set Standards-Version to 3.7.2 (no changes needed).
  * Removed PS and DVI stanzas from debian/doc-base as we don't build
    the documentation those ways.
  * Removed content-free postinst and prerm.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Thu, 26 Oct 2006 22:52:14 +0000

happy (1.15-2) unstable; urgency=low

  * Revert unnecessary strictification of ghc6 build-dep to make
    backports simpler.
  * Build-dep on docbook-xml so we don't need to get things from the
    'net when building.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Tue, 13 Sep 2005 17:58:31 +0100

happy (1.15-1.1) unstable; urgency=low

  * NMU to make installable in unstable.
  * Rebuild against newer GHC6 to link to appropriate libgmp.
  * Remove ghc5 from build-depends in debian/control.
  * Updated build-depends on ghc6 to 6.4-4.1 to make sure that
    the package gets built with the appropriate ghc6 that includes the
    libgmp fix.

 -- John Goerzen <jgoerzen@complete.org>  Fri,  9 Sep 2005 06:33:04 -0500

happy (1.15-1) unstable; urgency=low

  * New upstream version.
  * Don't build ps documentation due to xmltex bug #181444 and friends.
  * Build-dep on xsltproc, docbook-xsl for the HTML documentation.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Fri, 28 Jan 2005 22:47:45 +0000

happy (1.14-1) unstable; urgency=low

  * New upstream version.
  * Change how configure/config.sub/config.guess are handled in line
    with /usr/share/doc/autotools-dev/README.Debian.gz.
  * Added mipsel and x86_64 to configure{,.ac}. Closes: #253166.
  * Get rid of unportable {a,b} syntax in debian/rules.
  * Say we replace ghc-cvs (<< 20031221) as old ghc-cvs accidentally
    included happy.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Thu, 08 Jul 2004 23:15:11 +0000

happy (1.13-0tarball-5) unstable; urgency=low



=== debian/control ===
Source: happy
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@ubuntu.com>
Standards-Version: 3.8.4
Build-Depends: cdbs (>= 0.4.59), 
               haskell-devscripts (>= 0.7),
               debhelper (>= 7),
               autoconf,
               docbook-utils,
               ghc6,
               docbook-xsl,
               docbook-xml,
               xsltproc,
               happy,
               libghc6-mtl-dev
Homepage: http://www.haskell.org/happy
Vcs-Darcs: http://darcs.debian.org/darcs/pkg-haskell/happy
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/happy


Package: happy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${haskell:Depends}
Recommends: ${haskell:Recommends}
Suggests: haskell-doc, info-browser, ${haskell:Suggests}
Replaces: ghc-cvs (<< 20031221)
Description: Parser generator for Haskell
 Happy is a parser generator system for Haskell, similar to the tool `yacc' for
 C. Like `yacc', it takes a file containing an annotated BNF specification of a
 grammar and produces a Haskell module containing a parser for the grammar.
 .
 Happy is flexible: you can have several Happy parsers in the same program, and
 several entry points to a single grammar. Happy can work in conjunction with a
 lexical analyser supplied by the user (either hand-written or generated by
 another program), or it can parse a stream of characters directly (but this
 isn't practical in most cases).

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.
# Largely rewritten for the Cabalised happy by Ian Lynagh in 2006.
# Largely rewritten for cdbs and hlibrary.mk by Iain Lane in 2009.

DEB_BUILD_DEPENDENCIES = build-arch

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk
include /usr/share/cdbs/1/rules/utils.mk

clean::
	[ ! -f doc/config.mk ] || $(MAKE) -C doc clean

	rm -f debian/get_version.o debian/get_version.hi debian/get_version
	rm -f doc/happy.1
	rm -rf out

	# Hacks:
	rm -f doc/config.log doc/config.status doc/config.mk doc/configure

configure/happy::
	# doc/configure is not shipped, generate it
	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr

	# make directory for the templates
	[ -d out ] || mkdir out

	# used in build to stick version into man page
	ghc6 --make debian/get_version.hs -o debian/get_version

build/happy:: build-ghc6-stamp
	$(MAKE) -C doc html
	sed -e "s#@LIBDIR@#/usr/share/happy-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/happy#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  doc/happy.1.in > doc/happy.1

# install templates to appropriate directory
binary-post-install/happy::
	rm -f $(CURDIR)/out/*bak
	mkdir -p           $(CURDIR)/debian/happy/usr/share/happy-`debian/get_version`/
	cp $(CURDIR)/out/* $(CURDIR)/debian/happy/usr/share/happy-`debian/get_version`/

## happy 1.18.6

=== debian/changelog ===
happy (1.18.6-1) unstable; urgency=low

  [ Marco Silva ]
  * Use ghc instead of ghc6

  [ Joachim Breitner ]
  * New upstream release 

 -- Joachim Breitner <nomeata@debian.org>  Tue, 29 Mar 2011 13:55:39 +0530

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,12 @@
                debhelper (>= 7),
                autoconf,
                docbook-utils,
-               ghc6,
+               ghc,
                docbook-xsl,
                docbook-xml,
                xsltproc,
                happy,
-               libghc6-mtl-dev
+               libghc-mtl-dev
 Homepage: http://www.haskell.org/happy
 Vcs-Darcs: http://darcs.debian.org/darcs/pkg-haskell/happy
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/happy

=== debian/rules ===
--- 
+++ 
@@ -29,9 +29,9 @@
 	[ -d out ] || mkdir out
 
 	# used in build to stick version into man page
-	ghc6 --make debian/get_version.hs -o debian/get_version
+	ghc --make debian/get_version.hs -o debian/get_version
 
-build/happy:: build-ghc6-stamp
+build/happy:: build-ghc-stamp
 	$(MAKE) -C doc html
 	sed -e "s#@LIBDIR@#/usr/share/happy-`debian/get_version`#g" \
 	    -e "s#@DOCDIR@#/usr/share/doc/happy#g" \

## happy 1.18.9

=== tests/Makefile ===
--- 
+++ 
@@ -4,7 +4,8 @@
 TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
 	monad001.y monad002.ly precedence001.ly precedence002.y \
 	bogus-token.y bug002.y Partial.ly \
-	AttrGrammar001.y AttrGrammar002.y
+	AttrGrammar001.y AttrGrammar002.y \
+	test_rules.y monaderror.y
 
 ERROR_TESTS = error001.y
 
@@ -52,9 +53,6 @@
 %.agc.hs : %.y
 	$(HAPPY) $(TEST_HAPPY_OPTS) -agc $< -o $@
 
-%.o : %.hs
-	$(HC) $(HC_OPTS) -c -o $@ $<
-
 CLEAN_FILES += *.n.hs *.a.hs *.g.hs *.gc.hs *.ag.hs *.agc.hs *.info *.hi *.bin *.exe
 
 ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}y/\1.n.hs \1.a.hs \1.g.hs \1.gc.hs \1.ag.hs \1.agc.hs/g')
@@ -63,7 +61,7 @@
 
 CHECK_ERROR_TESTS = $(patsubst %, check.%, $(ERROR_TESTS))
 
-HC_OPTS += -fglasgow-exts -no-recomp
+HC_OPTS += -fglasgow-exts -fforce-recomp
 
 .PRECIOUS: *.hs *.o *.bin *.exe
 
@@ -77,7 +75,7 @@
 	@diff -u $*.stdout $*.run.stdout
 	@diff -u $*.stderr $*.run.stderr
 
-%$(HS_PROG_EXT) : %.o
+%$(HS_PROG_EXT) : %.hs
 	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@
 
 all :: $(CHECK_ERROR_TESTS) $(ALL_TESTS)

=== debian/changelog ===
happy (1.18.9-1) unstable; urgency=low

  * New upstream release
  * Simplify build setup a bit 

 -- Joachim Breitner <nomeata@debian.org>  Tue, 07 Feb 2012 21:40:11 +0100

=== debian/control ===
--- 
+++ 
@@ -13,8 +13,8 @@
                docbook-xsl,
                docbook-xml,
                xsltproc,
-               happy,
-               libghc-mtl-dev
+               libghc-mtl-dev,
+               happy
 Homepage: http://www.haskell.org/happy
 Vcs-Darcs: http://darcs.debian.org/darcs/pkg-haskell/happy
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/happy

## happy 1.18.10

=== debian/changelog ===
happy (1.18.10-2) unstable; urgency=low

  * Enable compat level 9

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 12:49:45 +0200

happy (1.18.10-1) experimental; urgency=low

  * Depend on haskell-devscripts 0.8.13 to ensure this packages is built
    against experimental
  * Bump standards version, no change
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sat, 20 Oct 2012 00:13:49 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Iain Lane <laney@ubuntu.com>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.4
 Build-Depends: cdbs (>= 0.4.59), 
-               haskell-devscripts (>= 0.7),
-               debhelper (>= 7),
+               haskell-devscripts (>= 0.8.13),
+               debhelper (>= 9),
                autoconf,
                docbook-utils,
                ghc,

## happy 1.19.0

=== tests/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 HAPPY=../dist/build/happy/happy
-HC=ghc
+HC=ghc -hide-all-packages -package base -package array -package mtl -fwarn-lazy-unlifted-bindings -Werror
 
 TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
 	monad001.y monad002.ly precedence001.ly precedence002.y \
@@ -61,9 +61,9 @@
 
 CHECK_ERROR_TESTS = $(patsubst %, check.%, $(ERROR_TESTS))
 
-HC_OPTS += -fglasgow-exts -fforce-recomp
+HC_OPTS += -fforce-recomp
 
-.PRECIOUS: *.hs *.o *.bin *.exe
+.PRECIOUS: %.hs %.o %.bin %.$(HS_PROG_EXT)
 
 %.run : %$(HS_PROG_EXT)
 	@echo "--> Checking $<..."
@@ -93,3 +93,8 @@
 	$(HC) Test.hs -o happy_test
 	./happy_test
 	-rm -f ./happy_test
+
+.PHONY: clean
+
+clean:
+	$(RM) $(CLEAN_FILES)

=== examples/glr/Makefile ===

all : 
	make loop CMD=run

clean : 
	make loop CMD=clean

DIRS = expr-eval expr-tree expr-monad \
       hidden-leftrec highly-ambiguous packing \
       nlp bio-eg

loop :
	for d in ${DIRS}; do (cd $$d && make ${CMD}); done

=== examples/glr/expr-monad/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 
 expr : Expr.hs Main.lhs 
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
 
 run : expr
 	./expr "1+2*4-3"

=== examples/glr/hidden-leftrec/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 include ${TOP}/Makefile.defs
 
 expr : Expr.hs Main.lhs
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
 
 run : expr
 	./expr "+ 1 1 1 1 1 1 "

=== examples/glr/highly-ambiguous/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 include ${TOP}/Makefile.defs
 
 expr : Expr.hs Main.lhs
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
 
 NUM=20
 run : expr

=== debian/changelog ===
happy (1.19.0-1) unstable; urgency=low

  * Fix Vcs-Darcs url: http://darcs.debian.org/ instead of
    http://darcs.debian.org/darcs/
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Wed, 18 Sep 2013 19:11:12 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libghc-mtl-dev,
                happy
 Homepage: http://www.haskell.org/happy
-Vcs-Darcs: http://darcs.debian.org/darcs/pkg-haskell/happy
+Vcs-Darcs: http://darcs.debian.org/pkg-haskell/happy
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/happy

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 # Largely rewritten for cdbs and hlibrary.mk by Iain Lane in 2009.
 
 DEB_BUILD_DEPENDENCIES = build-arch
+
+DEB_SETUP_GHC_CONFIGURE_ARGS := --datasubdir=/usr/share/happy --docdir=/usr/share/doc/happy
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/class/hlibrary.mk
@@ -16,7 +18,6 @@
 
 	rm -f debian/get_version.o debian/get_version.hi debian/get_version
 	rm -f doc/happy.1
-	rm -rf out
 
 	# Hacks:
 	rm -f doc/config.log doc/config.status doc/config.mk doc/configure
@@ -24,10 +25,6 @@
 configure/happy::
 	# doc/configure is not shipped, generate it
 	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr
-
-	# make directory for the templates
-	[ -d out ] || mkdir out
-
 	# used in build to stick version into man page
 	ghc --make debian/get_version.hs -o debian/get_version
 
@@ -40,6 +37,5 @@
 
 # install templates to appropriate directory
 binary-post-install/happy::
-	rm -f $(CURDIR)/out/*bak
-	mkdir -p           $(CURDIR)/debian/happy/usr/share/happy-`debian/get_version`/
-	cp $(CURDIR)/out/* $(CURDIR)/debian/happy/usr/share/happy-`debian/get_version`/
+	$(DEB_SETUP_BIN_NAME) copy --builddir=dist-ghc --destdir=debian/happy
+	rm -f debian/happy/usr/share/doc/happy/LICENSE

=== debian/watch ===
version=3
opts="downloadurlmangle=s|archive/([\w\d_-]+)/([\d\.]+)/|archive/$1/$2/$1-$2.tar.gz|,\
filenamemangle=s|(.*)/$|happy-$1.tar.gz|" \
    http://hackage.haskell.org/packages/archive/happy \
    ([\d\.]*\d)/

## happy 1.19.4

=== debian/changelog ===
happy (1.19.4-1) unstable; urgency=medium

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Wed, 06 Aug 2014 17:46:22 +0200

happy (1.19.3-1) unstable; urgency=low

  * Adjust watch file to new hackage layout
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sun, 09 Mar 2014 11:14:29 +0100

## happy 1.19.5

=== tests/Makefile ===
--- 
+++ 
@@ -1,5 +1,14 @@
 HAPPY=../dist/build/happy/happy
-HC=ghc -hide-all-packages -package base -package array -package mtl -fwarn-lazy-unlifted-bindings -Werror
+HC=ghc
+HC_OPTS=-hide-all-packages -package base -package array -package mtl -Werror
+
+.PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
+
+ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
+HS_PROG_EXT = .exe
+else
+HS_PROG_EXT = .bin
+endif
 
 TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
 	monad001.y monad002.ly precedence001.ly precedence002.y \
@@ -10,12 +19,6 @@
 ERROR_TESTS = error001.y
 
 TEST_HAPPY_OPTS = --strict --template=..
-
-ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
-HS_PROG_EXT = .exe
-else
-HS_PROG_EXT = .bin
-endif
 
 %.n.hs : %.ly
 	$(HAPPY) $(TEST_HAPPY_OPTS) $< -o $@

=== examples/igloo/Makefile ===

all:
	alex Lexer.x
	happy Parser.y
	ghc --make Foo -o foo

test:
	echo fork leaf leaf | ./foo
	echo fork leaf leafqleaf | ./foo
	echo leaf leaf leaf leaf leaf | ./foo

clean:
	rm -f *.o *.hi Parser.hs Lexer.hs foo

=== examples/glr/bio-eg/Makefile ===
--- 
+++ 
@@ -11,18 +11,18 @@
 	@ dummy 
 
 ${PROG} : Bio.o Main.lhs 
-	${GHC} -cpp -fglasgow-exts -package lang -o ${PROG} --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o ${PROG} --make Main.lhs
 
 BioData.hs Bio.hs : Bio.y
 	${HAPPY} --info --glr --ghc ${FILTER} $< 
 
 Bio.o : Bio.hs BioData.hi
-	${GHC} -cpp -fglasgow-exts -package lang -O2 -c Bio.hs
+	${GHC} -cpp -fglasgow-exts  -O2 -c Bio.hs
 
 DATA_FLAGS = -funfolding-use-threshold0 -fno-strictness 
 BioData.hi BioData.o : BioData.hs 
 	@echo "Making BioData.hs WITHOUT optimisation (for speed)"
-	${GHC} -cpp -fglasgow-exts -package lang ${DATA_FLAGS} -c $<
+	${GHC} -cpp -fglasgow-exts  ${DATA_FLAGS} -c $<
 
 run : run12

=== examples/glr/expr-eval/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 expr : Expr.hs Main.lhs 
 	# might want to run happy with --ghc
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
 
 run : expr
 	./expr "1+2*4-3"

=== examples/glr/expr-tree/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 expr : Expr.hs Main.lhs 
 	# might want to run happy with --ghc
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
                                                                                 
 run : expr
 	./expr "1+2*4-3"

=== examples/glr/highly-ambiguous/Makefile ===
--- 
+++ 
@@ -7,7 +7,6 @@
 NUM=20
 run : expr
 	./expr +RTS -s -RTS ${NUM} | grep ^Ok
-	egrep '' expr.stat > out${NUM}
 
 run30 : 
 	make run NUM=30

=== examples/glr/nlp/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 include ${TOP}/Makefile.defs
 
 english : English.hs Main.lhs 
-	${GHC} -cpp -fglasgow-exts -package lang -o english --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o english --make Main.lhs
 
 run : english
 	./english "the man saw the race with a telescope"

=== examples/glr/packing/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	${HAPPY} -i -l $*.y ${FILTER}
 
 expr : Expr.hs Main.lhs
-	${GHC} -cpp -fglasgow-exts -package lang -o expr --make Main.lhs
+	${GHC} -cpp -fglasgow-exts  -o expr --make Main.lhs
 
 run : expr
 	./expr "+ 1 1 1 1 1 1 "

=== debian/changelog ===
happy (1.19.5-5) unstable; urgency=medium

  * Implement a stage1 profile build for bootstrapping.

 -- Colin Watson <cjwatson@debian.org>  Tue, 22 Dec 2015 02:39:03 +0000

happy (1.19.5-4) unstable; urgency=medium

  * Switch Vcs-Git/Vcs-Browser headers to new location.

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 14:54:02 -0500

happy (1.19.5-3) experimental; urgency=medium

  * rpath lintian override

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 14:43:49 +0200

happy (1.19.5-2) experimental; urgency=medium

  * Support latest Cabal
  * Bump standards-version to 3.9.6
  * Depend on haskell-devscripts >= 0.10 to ensure that this package
    builds against GHC in experimental

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 10:26:53 +0200

happy (1.19.5-1) unstable; urgency=medium

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Mon, 29 Jun 2015 11:18:44 +0200

happy (1.19.4-3) unstable; urgency=medium

  * Upload to unstable

 -- Joachim Breitner <nomeata@debian.org>  Mon, 27 Apr 2015 11:47:29 +0200

happy (1.19.4-2) experimental; urgency=medium

  * Depend on haskell-devscripts 0.9, found in experimental

 -- Joachim Breitner <nomeata@debian.org>  Sat, 20 Dec 2014 17:09:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,21 +3,22 @@
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Iain Lane <laney@ubuntu.com>
-Standards-Version: 3.9.4
-Build-Depends: cdbs (>= 0.4.59), 
-               haskell-devscripts (>= 0.8.13),
-               debhelper (>= 9),
+Standards-Version: 3.9.6
+Build-Depends: cdbs (>= 0.4.59),
+               haskell-devscripts (>= 0.10),
+               debhelper (>= 9.20141010),
+               dpkg-dev (>= 1.17.14),
                autoconf,
                docbook-utils,
-               ghc,
+               ghc (>= 7.10),
                docbook-xsl,
                docbook-xml,
                xsltproc,
                libghc-mtl-dev,
-               happy
+               happy <!stage1>
 Homepage: http://www.haskell.org/happy
-Vcs-Darcs: http://darcs.debian.org/pkg-haskell/happy
-Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/happy
+Vcs-Git: git://git.debian.org/git/pkg-haskell/DHG_packages.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
 
 
 Package: happy

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,13 @@
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/class/hlibrary.mk
 include /usr/share/cdbs/1/rules/utils.mk
+
+ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
+DEB_SETUP_GHC_CONFIGURE_ARGS += --with-happy=/bin/true
+
+cleanbuilddir/happy::
+	cp -a dist/build/happy/happy-tmp/*.hs src/
+endif
 
 clean::
 	[ ! -f doc/config.mk ] || $(MAKE) -C doc clean

## happy 1.19.8

=== Makefile ===
HAPPY = happy 
HAPPY_OPTS = -agc

ALEX = alex
ALEX_OPTS = -g

sdist ::
	@if [ "`git status -s`" != '' ]; then \
		echo Tree is not clean; \
		exit 1; \
	fi
	$(HAPPY) $(HAPPY_OPTS) src/Parser.ly -o src/Parser.hs
	$(HAPPY) $(HAPPY_OPTS) src/AttrGrammarParser.ly -o src/AttrGrammer.hs
	mv src/Parser.ly src/Parser.ly.boot
	mv src/AttrGrammarParser.ly src/AttrGrammarParser.ly.boot
	cabal sdist
	git checkout .
	git clean -f

=== examples/glr/highly-ambiguous/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 run : expr
 	./expr +RTS -s -RTS ${NUM} | grep ^Ok
 
-run30 : 
+run30 :
 	make run NUM=30
 
 test : run eof err
@@ -17,5 +17,5 @@
 	rm -rf expr Expr.info Expr.hs ExprData.hs *.o *.hi out.daVinci
 
 tar :
-	tar chzf aj2.tgz Expr*hs Expr*y Main*hs D*hs 
+	tar chzf aj2.tgz Expr*hs Expr*y Main*hs D*hs

=== debian/changelog ===
happy (1.19.8-1) unstable; urgency=medium

  * New upstream release (Closes: #876605)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 24 Oct 2017 00:46:34 +0300

happy (1.19.7-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 16 Sep 2017 13:14:37 -0700

happy (1.19.6-1) unstable; urgency=medium

  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 03 Sep 2017 19:07:11 -0700

happy (1.19.5-7) unstable; urgency=medium

  * Upload to unstable as part of GHC 8 transition.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 18:32:18 -0400

happy (1.19.5-6) experimental; urgency=medium

  [ Dmitry Bogatov ]
  * Use secure (https) uri in Vcs-Git field in 'debian/control'
  * Bump standards version to 3.9.8 (no changes needed)
  * Convert 'debian/copyright' to dep5 format

  [ Clint Adams ]
  * Temporarily build-depend on ghc 8.

 -- Clint Adams <clint@debian.org>  Thu, 13 Oct 2016 14:03:29 -0400

=== debian/control ===
Source: happy
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@ubuntu.com>
Priority: extra
Section: haskell
Standards-Version: 3.9.8
Build-Depends:
 cdbs (>= 0.4.59),
 haskell-devscripts (>= 0.13),
 debhelper (>= 9.20141010),
 dpkg-dev (>= 1.17.14),
 autoconf,
 docbook-utils,
 ghc (>= 8),
 ghc-prof,
 docbook-xsl,
 docbook-xml,
 xsltproc,
 libghc-mtl-dev (>= 2.2.1),
 happy <!stage1>,
Homepage: https://www.haskell.org/happy/
Vcs-Git: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/tree/p/happy

Package: happy
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${haskell:Depends},
Recommends: ${haskell:Recommends},
Suggests: haskell-doc,
 info-browser,
 ${haskell:Suggests},
Replaces: ghc-cvs (<< 20031221),
Description: Parser generator for Haskell
 Happy is a parser generator system for Haskell, similar to the tool `yacc' for
 C. Like `yacc', it takes a file containing an annotated BNF specification of a
 grammar and produces a Haskell module containing a parser for the grammar.
 .
 Happy is flexible: you can have several Happy parsers in the same program, and
 several entry points to a single grammar. Happy can work in conjunction with a
 lexical analyser supplied by the user (either hand-written or generated by
 another program), or it can parse a stream of characters directly (but this
 isn't practical in most cases).

=== debian/watch ===
version=3
http://hackage.haskell.org/package/happy/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## happy 1.19.9

=== tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,13 @@
 HAPPY=../dist/build/happy/happy
-HC=ghc
-HC_OPTS=-hide-all-packages -package base -package array -package mtl -Werror
+HC_OPTS=-hide-all-packages -package base -package array -package mtl -Wall -Werror
+
+ifeq ($(wildcard ../cabal.sandbox.config),)
+    HC = ghc
+    SANDBOX_CONFIG =
+else
+    HC = cabal exec -- ghc
+    SANDBOX_CONFIG = cabal.sandbox.config
+endif
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
@@ -13,8 +20,10 @@
 TESTS = Test.ly TestMulti.ly TestPrecedence.ly bug001.ly \
 	monad001.y monad002.ly precedence001.ly precedence002.y \
 	bogus-token.y bug002.y Partial.ly \
+	issue91.y issue93.y issue94.y issue95.y \
 	AttrGrammar001.y AttrGrammar002.y \
-	test_rules.y monaderror.y
+	test_rules.y monaderror.y monaderror-explist.y \
+	typeclass_monad001.y typeclass_monad002.ly typeclass_monad_lexer.y
 
 ERROR_TESTS = error001.y
 
@@ -56,7 +65,7 @@
 %.agc.hs : %.y
 	$(HAPPY) $(TEST_HAPPY_OPTS) -agc $< -o $@
 
-CLEAN_FILES += *.n.hs *.a.hs *.g.hs *.gc.hs *.ag.hs *.agc.hs *.info *.hi *.bin *.exe
+CLEAN_FILES += *.n.hs *.a.hs *.g.hs *.gc.hs *.ag.hs *.agc.hs *.info *.hi *.bin *.exe *.o *.run.stdout *.run.stderr $(SANDBOX_CONFIG)
 
 ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}y/\1.n.hs \1.a.hs \1.g.hs \1.gc.hs \1.ag.hs \1.agc.hs/g')
 
@@ -75,13 +84,13 @@
 check.%.y : %.y
 	@echo "--> Checking $<..."
 	$(HAPPY) $(TEST_HAPPY_OPTS) $< 1>$*.run.stdout 2>$*.run.stderr || true
-	@diff -u $*.stdout $*.run.stdout
-	@diff -u $*.stderr $*.run.stderr
+	@diff -u --ignore-all-space $*.stdout $*.run.stdout
+	@diff -u --ignore-all-space $*.stderr $*.run.stderr
 
 %$(HS_PROG_EXT) : %.hs
 	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@
 
-all :: $(CHECK_ERROR_TESTS) $(ALL_TESTS)
+all :: $(SANDBOX_CONFIG) $(CHECK_ERROR_TESTS) $(ALL_TESTS)
 
 check-todo::
 	$(HAPPY) $(TEST_HAPPY_OPTS) -ad Test.ly
@@ -101,3 +110,6 @@
 
 clean:
 	$(RM) $(CLEAN_FILES)
+
+cabal.sandbox.config:
+	cabal sandbox init --sandbox=../.cabal-sandbox

=== debian/changelog ===
happy (1.19.9-4) unstable; urgency=medium

  * Set Rules-Requires-Root to no.
  * Install README.md instead of README.  closes: #903332.

 -- Clint Adams <clint@debian.org>  Sat, 14 Jul 2018 14:20:35 -0400

happy (1.19.9-3) unstable; urgency=medium

  * Use Distribution.Version instead.

 -- Clint Adams <clint@debian.org>  Thu, 12 Apr 2018 14:42:41 -0400

happy (1.19.9-2) unstable; urgency=medium

  * Hide Distribution.Version's showVersion in our get_version util.

 -- Clint Adams <clint@debian.org>  Thu, 12 Apr 2018 10:39:31 -0400

happy (1.19.9-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Change Priority to optional. Since Debian Policy version 4.0.1,
    priority extra has been deprecated.
  * Use the HTTPS form of the copyright-format URL
  * Modify d/watch and Source field in d/copyright to use HTTPS
  * Declare compliance with Debian policy 4.1.1
  * Use salsa.debian.org URLs in Vcs-{Browser,Git} fields

  [ Clint Adams ]
  * Bump to Standards-Version 4.1.4.
  * New upstream release

 -- Clint Adams <clint@debian.org>  Mon, 09 Apr 2018 15:06:48 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: happy
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Iain Lane <laney@ubuntu.com>
-Priority: extra
+Priority: optional
 Section: haskell
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
+Rules-Requires-Root: no
 Build-Depends:
  cdbs (>= 0.4.59),
  haskell-devscripts (>= 0.13),
@@ -19,8 +20,8 @@
  libghc-mtl-dev (>= 2.2.1),
  happy <!stage1>,
 Homepage: https://www.haskell.org/happy/
-Vcs-Git: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/tree/p/happy
+Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/happy]
+Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/happy
 
 Package: happy
 Architecture: any

## happy 1.19.11

=== doc/Makefile ===
include config.mk

XML_DOC = happy
INSTALL_XML_DOC = happy

include docbook-xml.mk

=== tests/Makefile ===
--- 
+++ 
@@ -23,7 +23,8 @@
 	issue91.y issue93.y issue94.y issue95.y \
 	AttrGrammar001.y AttrGrammar002.y \
 	test_rules.y monaderror.y monaderror-explist.y \
-	typeclass_monad001.y typeclass_monad002.ly typeclass_monad_lexer.y
+	typeclass_monad001.y typeclass_monad002.ly typeclass_monad_lexer.y \
+	rank2.y
 
 ERROR_TESTS = error001.y

=== examples/igloo/Makefile ===

all:
	alex Lexer.x
	happy Parser.y
	ghc --make Foo -o foo

test:
	echo fork leaf leaf | ./foo
	-echo fork leaf leafqleaf | ./foo
	-echo leaf leaf leaf leaf leaf | ./foo
	@echo ok

clean:
	rm -f *.o *.hi Parser.hs Lexer.hs foo

=== debian/changelog ===
happy (1.19.11-2) unstable; urgency=medium

  * Don't copy source code files for stage1 builds (Closes: #884750)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 29 Jan 2020 11:33:06 +0100

happy (1.19.11-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Sat, 27 Jul 2019 20:29:39 -0400

happy (1.19.9-6) unstable; urgency=medium

  * debian/get_version.hs: Updated for Cabal 2.2

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 03 Oct 2018 14:45:54 +0300

happy (1.19.9-5) unstable; urgency=medium

  * Bump debhelper compat level to 10
  * Remove build dependency on libghc-mtl-dev (provided by ghc-8.4.3)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 01 Oct 2018 13:33:21 +0300

## happy 1.19.12

=== Makefile ===
CABAL = cabal

HAPPY = happy 
HAPPY_OPTS = -agc
HAPPY_VER = `awk '/^version:/ { print $$2 }' happy.cabal`

ALEX = alex
ALEX_OPTS = -g

SDIST_DIR=dist-newstyle/sdist

GEN = src/gen/Parser.hs src/gen/AttrGrammarParser.hs

all : $(GEN)

src/gen/%.hs : src/boot/%.ly
	$(HAPPY) $(HAPPYFLAGS) $< -o $@

sdist ::
	@case "`$(CABAL) --numeric-version`" in \
		2.[2-9].* | [3-9].* ) ;; \
		* ) echo "Error: needs cabal 2.2.0.0 or later (but got : `$(CABAL) --numeric-version`)" ; exit 1 ;; \
	esac
	@if [ "`git status -s`" != '' ]; then \
		echo Tree is not clean; \
		exit 1; \
	fi
	$(HAPPY) $(HAPPY_OPTS) src/Parser.ly -o src/Parser.hs
	$(HAPPY) $(HAPPY_OPTS) src/AttrGrammarParser.ly -o src/AttrGrammarParser.hs
	mv src/Parser.ly src/Parser.ly.boot
	mv src/AttrGrammarParser.ly src/AttrGrammarParser.ly.boot
	$(CABAL) new-run gen-happy-sdist 
	cabal v2-sdist
	@if [ ! -f "${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz" ]; then \
		echo "Error: source tarball not found: dist/happy-$(HAPPY_VER).tar.gz"; \
		exit 1; \
	fi
	git checkout .
	git clean -f

sdist-test :: sdist sdist-test-only
	@rm -rf "${SDIST_DIR}/happy-${HAPPY_VER}/"

sdist-test-only ::
	@if [ ! -f "${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz" ]; then \
		echo "Error: source tarball not found: ${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz"; \
		exit 1; \
	fi
	rm -rf "${SDIST_DIR}/happy-$(HAPPY_VER)/"
	tar -xf "${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz" -C ${SDIST_DIR}/
	echo "packages: ." > "${SDIST_DIR}/happy-$(HAPPY_VER)/cabal.project"
	cd "${SDIST_DIR}/happy-$(HAPPY_VER)/" && cabal v2-test --enable-tests all
	@echo ""
	@echo "Success! ${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz is ready for distribution!"
	@echo ""

=== tests/Makefile ===
--- 
+++ 
@@ -1,13 +1,18 @@
+# NOTE: `cabal test` will take care to build the local `happy`
+# executable and place it into $PATH for us to pick up.  
+# 
+# If it doesn't look like the alex binary in $PATH comes from the
+# build tree, then we'll fall back to pointing to
+# ../dist/build/alex/alex to support running tests via "runghc
+# Setup.hs test".
+#
+HAPPY=$(shell which happy)
+ifeq "$(filter $(dir $(shell pwd))%,$(HAPPY))" ""
 HAPPY=../dist/build/happy/happy
-HC_OPTS=-hide-all-packages -package base -package array -package mtl -Wall -Werror
+endif
 
-ifeq ($(wildcard ../cabal.sandbox.config),)
-    HC = ghc
-    SANDBOX_CONFIG =
-else
-    HC = cabal exec -- ghc
-    SANDBOX_CONFIG = cabal.sandbox.config
-endif
+HC = ghc
+HC_OPTS=-Wall -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
@@ -28,7 +33,9 @@
 
 ERROR_TESTS = error001.y
 
-TEST_HAPPY_OPTS = --strict --template=..
+# NOTE: `cabal` will set the `happy_datadir` env-var accordingly before invoking the test-suite
+#TEST_HAPPY_OPTS = --strict --template=..
+TEST_HAPPY_OPTS = --strict
 
 %.n.hs : %.ly
 	$(HAPPY) $(TEST_HAPPY_OPTS) $< -o $@

=== examples/glr/hidden-leftrec/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	./expr ""
 
 err : expr
-	echo testing syntax error 
+	echo testing syntax error
 	./expr "+ 1 +"
 
 test : run eof err

=== examples/glr/nlp/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 TOP=..
 include ${TOP}/Makefile.defs
 
-english : English.hs Main.lhs 
+english : English.hs Main.lhs
 	${GHC} -cpp -fglasgow-exts  -o english --make Main.lhs
 
 run : english
@@ -12,7 +12,7 @@
 	./english "the man saw a"
 
 err : english
-	echo testing syntax error 
+	echo testing syntax error
 	./english "the the man saw race"
 
 test : run eof err

=== debian/changelog ===
happy (1.19.12-2build1) groovy; urgency=medium

  * No-change rebuild against libffi8ubuntu1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Aug 2020 00:05:00 +0000

happy (1.19.12-2) unstable; urgency=medium

  * Patch debian/get_version.hs for newer Cabal.

 -- Clint Adams <clint@debian.org>  Tue, 02 Jun 2020 17:31:52 -0400

happy (1.19.12-1) unstable; urgency=medium

  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 26 May 2020 09:26:51 -0700

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: happy
-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Iain Lane <laney@ubuntu.com>
 Priority: optional
 Section: haskell
@@ -8,16 +9,15 @@
 Build-Depends:
  cdbs (>= 0.4.59),
  haskell-devscripts (>= 0.13),
- debhelper (>= 9.20141010),
+ debhelper (>= 10),
  dpkg-dev (>= 1.17.14),
  autoconf,
  docbook-utils,
- ghc (>= 8),
+ ghc (>= 8.4.3),
  ghc-prof,
  docbook-xsl,
  docbook-xml,
  xsltproc,
- libghc-mtl-dev (>= 2.2.1),
  happy <!stage1>,
 Homepage: https://www.haskell.org/happy/
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/happy]

## happy 1.20.0

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	$(HAPPY) $(HAPPY_OPTS) src/AttrGrammarParser.ly -o src/AttrGrammarParser.hs
 	mv src/Parser.ly src/Parser.ly.boot
 	mv src/AttrGrammarParser.ly src/AttrGrammarParser.ly.boot
-	$(CABAL) new-run gen-happy-sdist 
+	$(CABAL) v2-run gen-happy-sdist 
 	cabal v2-sdist
 	@if [ ! -f "${SDIST_DIR}/happy-$(HAPPY_VER).tar.gz" ]; then \
 		echo "Error: source tarball not found: dist/happy-$(HAPPY_VER).tar.gz"; \

=== tests/Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	AttrGrammar001.y AttrGrammar002.y \
 	test_rules.y monaderror.y monaderror-explist.y \
 	typeclass_monad001.y typeclass_monad002.ly typeclass_monad_lexer.y \
-	rank2.y
+	rank2.y shift01.y
 
 ERROR_TESTS = error001.y

=== debian/changelog ===
happy (1.20.0-1build1) lunar; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Dec 2022 13:57:44 +0100

happy (1.20.0-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Tue, 14 Jun 2022 13:00:27 -0400
